package it.unibo.tw0708.client;

import it.unibo.tw0708.dao.DAOFactory;
import it.unibo.tw0708.dao.UserDAO;

public class CleanDB {

	public static final int DEFAULT_DB = DAOFactory.HSQLDB;
	
	public static void main(String[] args) {
		
		// Scelta del database da usare: default o da argomenti
		int db = DEFAULT_DB;
		if ( args != null && args.length > 0 ) {
			try {
				if ( args[0].equalsIgnoreCase("mysql") )
					db = DAOFactory.MYSQL;
				else if ( args[0].equalsIgnoreCase("hsqldb") )
					db = DAOFactory.HSQLDB;
			}
			catch (Exception e) {
				System.out.println("Vabbe', ci abbiamo provato... usiamo HSQLDB");
			}
		}
		
		// Ottenimento dell'oggetto DAO con cui accedere al db
		UserDAO uDAO = DAOFactory.getDAOFactory(db).getUserDAO();
		
		// Piazza pulita
		System.out.print("Trying to drop user's table.... ");
		System.out.print("" + uDAO.dropTable() );
		System.out.println("Done.");
		return;
	}

}
