package it.unibo.tw0708.dao;

import java.util.Collection;

/**
 * DAO interface for accessing the user datatype
 * @author pisi79
 */
public interface UserDAO {

	// --- CRUD methods: create, read, update, delete

	/**
	 * C
	 */
	public int createUser(UserDTO t);

	/**
	 * R
	 */
	public UserDTO readUser(int id);

	/**
	 * U
	 */
	public boolean updateUser(UserDTO t);

	/**
	 * D
	 */
	public boolean deleteUser(UserDTO t);

	// --- Other access methods (read with selects and filters, read all, etc...) ---

	/**
	 * Find out an existing user by its nick
	 * @param nick
	 * @return a user DATA TRANSFER OBJECT
	 */
	public UserDTO findUser(String nick);

	/**
	 * Reads all existing users
	 */
	public Collection<UserDTO> getUsers();

	// --- Per comodità mettiamo nel DAO anche i metodi di creazione e distruzione delle tabelle, 
	// in modo da poterli richiamare in modo programmatico ---
	
	/**
	 * Creazione della table
	 */
	public boolean createTable();
	
	/**
	 * Rimozione della table
	 */
	public boolean dropTable();

}
