package it.unibo.tw0708.dao;

/**
 * Actual datatype representation for use by classes involved
 * in the webapp business logic
 * @author pisi79
 */
public class UserDTO {

	// --- Fields of the datatype -------------------------------------
	
	private int id;
	
	private String name;
	private String surname;
	private String address;
	private long matriculation;
	private String nick;
	private byte[] password;
	
	// --- Getters and setters -----------------------------------
	
	public long getMatriculation() {
		return matriculation;
	}
	public void setMatriculation(long matriculation) {
		this.matriculation = matriculation;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getNick() {
		return nick;
	}
	public void setNick(String nick) {
		this.nick = nick;
	}
	public byte[] getPassword() {
		return password;
	}
	public void setPassword(byte[] password) {
		this.password = password;
	}
	public String getSurname() {
		return surname;
	}
	public void setSurname(String surname) {
		this.surname = surname;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getAddress() {
		return address;
	}
	public void setAddress(String address) {
		this.address = address;
	}
	
	// --- Optional overriding of facility methods (toString, compare, hashcode, ...) ---
	
	@Override
	public String toString() {
		return 
			"user["+
				"id="+id+", "+
				"name="+name+", "+
				"surname="+surname+", "+
				"address="+address+", "+
				"matriculation="+matriculation+", "+
				"nick="+nick+", "+
				"password="+new String(password)+
			"]";
	}

	@Override
	public boolean equals(Object o) {
		if ( ! ( o instanceof UserDTO ) )
			return false;
		UserDTO u = (UserDTO)o;
		if ( u.getId() != this.getId() ) return false;
		if ( u.getMatriculation() != this.getMatriculation() ) return false;
		if ( ! compareStrings(u.getAddress(),this.getAddress()) ) return false;
		if ( ! compareStrings(u.getName(),this.getName()) ) return false;
		if ( ! compareStrings(u.getNick(),this.getNick()) ) return false;
		if ( ! compareStrings(u.getSurname(),this.getSurname()) ) return false;
		if ( ! compareArrays(u.getPassword(),this.getPassword()) ) return false;
		return true;
	}
	
	private boolean compareStrings(String s1, String s2) {
		if ( s1 == null ) {
			if ( s2 == null) return true;
			else return false;
		}
		return s1.equals(s2);
	}

	private boolean compareArrays(byte[] b2, byte[] b1) {
		if ( b1 == null ) {
			if ( b2 == null) return true;
			else return false;
		}
		if ( b1.length != b2.length) 
			return false;
		for ( int i = 0 ; i < b1.length ; i++ )
			if ( b1[i] != b2[i] ) return false;
		return true;
	}

}
