package it.unibo.tw0708.dao.mysql;

import it.unibo.tw0708.dao.DAOFactory;
import it.unibo.tw0708.dao.UserDAO;

import java.sql.Connection;
import java.sql.DriverManager;

public class MySqlDAOFactory 
extends DAOFactory {

	public static final String USERNAME = "webapp";
	public static final String PASSWORD = "webapppwd";
	public static final String DRIVER = "com.mysql.jdbc.Driver";
	public static final String DBURL = "jdbc:mysql://localhost:3306/usersdb";

	// --------------------------------------------

	static {
		try {
			Class.forName(DRIVER).newInstance();
		} 
		catch (Exception e) {
			System.err.println("MySqlDAOFactory.class: failed to load MySQL JDBC driver\n"+e);
			e.printStackTrace();
		}
	}

	// --------------------------------------------
	
	public static Connection createConnection() {
		try {
			Connection conn = DriverManager.getConnection (DBURL, USERNAME, PASSWORD);
			System.out.println(MySqlDAOFactory.class.getName()+".createConnection(): database connection established");
			return conn;
		} 
		catch (Exception e) {
			System.err.println(MySqlDAOFactory.class.getName()+".createConnection(): failed creating connection\n"+e);
			e.printStackTrace();
			return null;
		}
	}
	
	public static void closeConnection(Connection conn) {
		try {
			conn.close();
		}
		catch (Exception e) {
			System.err.println(MySqlDAOFactory.class.getName()+".closeConnection(): failed closing connection\n"+e);
			e.printStackTrace();
		}
	}

	// --------------------------------------------
	
	@Override
	public UserDAO getUserDAO() {
		return new MySqlUserDAO();
	}

//	/*
//	@Override
//	public OtherDataDAO getOtherDataDAO() {
//		// TODO Auto-generated method stub
//		return null;
//	}
//	*/

}
