package it.unibo.tw0708.web;

import it.unibo.tw0708.dao.DAOFactory;
import it.unibo.tw0708.dao.UserDAO;
import it.unibo.tw0708.dao.UserDTO;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * Another servlet
 *
 * @author you
 */
public class UpdateServlet 
extends HttpServlet {
	
	private static final long serialVersionUID = -7822739649809280754L;

	/**
	 * This servlet forwards the request processing of HTTP POST requests
	 * to the method handling HTTP GET ones.
	 * This way, the servlet can be invoked by submitting both request types
	 */
	public void doPost(HttpServletRequest request,
            HttpServletResponse response)
    throws IOException, ServletException {
    	this.doGet(request,response);
    }

	/**
	 * Requests are served by invoking library functions
	 * and returning html-wrapped results 
	 */
    public void doGet(HttpServletRequest request, HttpServletResponse response)
    throws IOException, ServletException {
    	
    	UserDAO userDAO = 
    		DAOFactory
    			.getDAOFactory(
    				Integer.parseInt(
    					super.getServletContext().getInitParameter("daoFactory")
    				)
    			).getUserDAO();
    	
    	String op = request.getParameter("op");
    	if (  op != null && op.equals("create") ) {
    		UserDTO userDTOtoCreate = new UserDTO();
			userDTOtoCreate.setAddress( request.getParameter("address") );
			userDTOtoCreate.setMatriculation( Long.parseLong(request.getParameter("matriculation")) );
			userDTOtoCreate.setName( request.getParameter("name") );
			userDTOtoCreate.setSurname( request.getParameter("surname") );
			userDTOtoCreate.setNick( request.getParameter("nick") );
			userDAO.createUser(userDTOtoCreate);    		
    	}

	   request.getRequestDispatcher("/otherpages/dao2.jsp").forward(request, response);

    }

}