<!doctype html public "-//w3c//dtd html 4.0 transitional//en">
<%@ page contentType="text/html; charset=US-ASCII" %>
<%@ page errorPage="../errorpages/failure.jsp"%>
<%@ page import="it.unibo.tw0708.dao.*" %>
<%@page import="java.util.*"%><html>

<%!
String makeInputField(String name, String value) {
	StringBuffer buffer = new StringBuffer();
	buffer.append("<input type=\"text\" name=\"").append(name).append("\" value=\"").append(value).append("\"/>");
	return buffer.toString();		
}

String makeHiddenField(String name, String value) {
	StringBuffer buffer = new StringBuffer();
	buffer.append("<input type=\"hidden\" name=\"").append(name).append("\" value=\"").append(value).append("\"/>");
	return buffer.toString();		
}

String buildTableRow(UserDTO userDTO) {
	StringBuffer buffer = new StringBuffer();
	buffer
		.append("<tr>")
			.append("<form method=\"get\">")
				.append("<td>")
				.append( makeInputField("name", userDTO.getName()) )
				.append("</td><td>")
				.append( makeInputField("surname", userDTO.getSurname()) )
				.append("</td><td>")
				.append( makeInputField("nick", userDTO.getNick()) )
				.append("</td><td>")
				.append( makeInputField("matriculation", ""+userDTO.getMatriculation()) )
				.append("</td><td>")
				.append( makeInputField("address", ""+userDTO.getAddress()) )
				.append("</td><td>")
				.append( makeHiddenField("id", ""+userDTO.getId()) )
				.append( makeHiddenField("op", "update") )
				.append("<input type=\"submit\" value=\"Applica modifiche\" />")
				.append("</td>")
			.append("</form>")
			.append("<td>")
				.append("<a href=\"?op=delete&id="+userDTO.getId()+"\"><img alt=\"delete\" src=\"../images/delete.gif\"/></a>")
			.append("</td>")
		.append("</tr>");
	return buffer.toString();		
}
%>

<%
UserDAO userDAO = 
	DAOFactory
		.getDAOFactory(
			Integer.parseInt(
				// can't use builtin object 'application' while in a declaration! 
				// must be in a scriptlet or expression!
				application.getInitParameter("daoFactory")
			)
		).getUserDAO();
%>

<head>
	<meta name="Author" content="pisi79">
	<title>Dealing with DAO (2)</title>
	<link rel="stylesheet" href="<%= request.getContextPath() %>/styles/default.css" type="text/css"/>
</head>

<body onload="document.getElementById('jspdao2').style.backgroundColor='#aaa';">
<%@ include file="../fragments/menu.jsp" %>

<div id="main">
<%
	String op = request.getParameter("op");
	if ( op != null ) {
		if ( op.equals("delete") ) {
			UserDTO userDTOtoDelete = userDAO.readUser( Integer.parseInt(request.getParameter("id")) );
			userDAO.deleteUser(userDTOtoDelete);
		}
		else if ( op.equals("update") ) {
			UserDTO userDTOtoUpdate = userDAO.readUser( Integer.parseInt(request.getParameter("id")) );
			userDTOtoUpdate.setAddress( request.getParameter("address") );
			userDTOtoUpdate.setMatriculation( Long.parseLong(request.getParameter("matriculation")) );
			userDTOtoUpdate.setName( request.getParameter("name") );
			userDTOtoUpdate.setSurname( request.getParameter("surname") );
			userDTOtoUpdate.setNick( request.getParameter("nick") );
			userDAO.updateUser(userDTOtoUpdate);
		}
	}
	if ( op != null ) {
%>
	<p>
		Operation '<%= op %>' was successful!<br/>
		<br/>
	</p>
<%		
	}// if
%>		
	<p>
		This is current database content for table 'user':
		<table>
				<thead><tr><th>Name</th><th>Surname</th><th>Nick</th><th>Matriculation</th><th>Address</th><th>Update</th><th>Delete</th></tr></thead>
<%
				Collection users = userDAO.getUsers();
			
				Iterator iterator = users.iterator();
				while ( iterator.hasNext() ) {
%>
					<%= buildTableRow( (UserDTO) iterator.next() ) %>	
<%
				}//while
%>
		</table>
	</p>
	<p>
		You can add more user, if you wish to:<br/>
		<fieldset>
			<legend>This awful form invokes a servlet, for the dirty job!</legend>
			<form action="../daoservlet" method="get" >
				Name:
				<input type="text" name="name"/><br/>
				Surname:
				<input type="text" name="surname"/><br/>
				Nick:
				<input type="text" name="nick"/><br/>
				Matriculation:
				<input type="text" name="matriculation"/> (must be a number!) <br/>
				Address:
				<input type="text" name="address"/><br/>
				<input type="hidden" name="op" value="create"/>
				<input type="submit" value="Create!"/><br/>
			</form>
		</fieldset>
	</p>
</div>

<%@ include file="../fragments/footer.jsp" %>
</body>
</html>
